import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';


import 'package:xui/compontent/index.dart';
import 'package:xui_example/api/Api.dart';
import 'package:xui_example/common/Icon_path.dart';

import '../routes_config.dart';

class HomePage extends StatefulWidget {
  @override
  _HomePageState createState() => _HomePageState();
}

class _HomePageState extends State<HomePage> with WidgetsBindingObserver {
  late List list = [
    _bottomIcon('日常运营', IconPath.home_Bg_4, '#FFA43B', Routes.login),
    _bottomIcon('订单管理', IconPath.home_Bg_1, '#A2DF7D', Routes.login),
    _bottomIcon('运营数据', IconPath.home_Bg_2, '#37CEFF', Routes.login),
    _bottomIcon('交账', IconPath.home_Bg_3, '#FF3DD6', Routes.login),
  ];

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    Api.context = context;
    _init();
  }

  void _init() async {
    String? token = await getToken();
    if (!isNotNull(token)) {
      Routers.pushNamed(Routes.login, callback: (v) {});
    } else {
      // JPushUtil.init();
    }
  }

  @override
  Widget build(BuildContext context) {
    ScreenUtil.init(context, designSize: Size(750, 1334), allowFontScaling: false);
    return _buildXCustomScrollView(context);
  }

  Future<bool> _onBackPressed() async {
    return await XAlert(context).showCenterTipsAlter(
      title: '提示',
      info: '确定退出程序吗！',
    );
  }

  Widget _buildXCustomScrollView(BuildContext context) {
    return WillPopScope(
      onWillPop: _onBackPressed,
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Text('home'),
        ],
      ),
    );
  }
}

class _bottomIcon {
  String? title;
  String? img;
  String? color;
  Routes? route;
  _bottomIcon(this.title, this.img, this.color, this.route);
}
